/* Generated by YAKINDU Statechart Tools for Arduino v0.4.0 */

#include "ArduinoPLC32.h"
#include <string.h>

/*! \file Implementation of the state machine 'arduinoPLC32'
*/

ArduinoPLC32::ArduinoPLC32()
{
	
	
	stateConfVectorPosition = 0;
	
	timer = null;
}

ArduinoPLC32::~ArduinoPLC32()
{
}


void ArduinoPLC32::init()
{
	for (int i = 0; i < maxOrthogonalStates; ++i)
		stateConfVector[i] = ArduinoPLC32_last_state;
	
	stateConfVectorPosition = 0;

	clearInEvents();
	clearOutEvents();
	
	/* Default init sequence for statechart arduinoPLC32 */
	iface.BPATU = 0;
	iface.AUTO_ID = 0;
	iface.M = false;
	iface.a1A1 = false;
	iface.a1B1 = false;
	iface.a2A1 = false;
	iface.a2B1 = false;
	iface.potA0 = 0;
	iface.potA1 = 0;
	iface.analogout1 = 0;
	iface.analogout2 = 0;
}

void ArduinoPLC32::enter()
{
	/* Default enter sequence for statechart arduinoPLC32 */
	enseq_main_region_default();
}

void ArduinoPLC32::exit()
{
	/* Default exit sequence for statechart arduinoPLC32 */
	exseq_main_region();
}

sc_boolean ArduinoPLC32::isActive()
{
	return stateConfVector[0] != ArduinoPLC32_last_state||stateConfVector[1] != ArduinoPLC32_last_state;
}

/* 
 * Always returns 'false' since this state machine can never become final.
 */
sc_boolean ArduinoPLC32::isFinal()
{
   return false;}

void ArduinoPLC32::runCycle()
{
	
	clearOutEvents();
	
	for (stateConfVectorPosition = 0;
		stateConfVectorPosition < maxOrthogonalStates;
		stateConfVectorPosition++)
		{
			
		switch (stateConfVector[stateConfVectorPosition])
		{
		case main_region_State10 :
		{
			react_main_region_State10();
			break;
		}
		case main_region_State11_r1_State21 :
		{
			react_main_region_State11_r1_State21();
			break;
		}
		case main_region_State11_r1_State20 :
		{
			react_main_region_State11_r1_State20();
			break;
		}
		case main_region_State11_r2_State0 :
		{
			react_main_region_State11_r2_State0();
			break;
		}
		case main_region_State11_r2_State1 :
		{
			react_main_region_State11_r2_State1();
			break;
		}
		case main_region_State11_r2_State2 :
		{
			react_main_region_State11_r2_State2();
			break;
		}
		case main_region_State11_r2_State3 :
		{
			react_main_region_State11_r2_State3();
			break;
		}
		case main_region_State11_r2_State4 :
		{
			react_main_region_State11_r2_State4();
			break;
		}
		case main_region_State11_r2_State5 :
		{
			react_main_region_State11_r2_State5();
			break;
		}
		default:
			break;
		}
	}
	
	clearInEvents();
}

void ArduinoPLC32::clearInEvents()
{
	iface.DCY_raised = false;
	iface.FCY_raised = false;
	iface.a1A6_raised = false;
	iface.a1B6_raised = false;
	iface.a2A6_raised = false;
	iface.a2B6_raised = false;
	timeEvents[0] = false; 
	timeEvents[1] = false; 
	timeEvents[2] = false; 
	timeEvents[3] = false; 
	timeEvents[4] = false; 
}

void ArduinoPLC32::clearOutEvents()
{
}


void ArduinoPLC32::setTimer(TimerInterface* timer)
{
	this->timer = timer;
}

TimerInterface* ArduinoPLC32::getTimer()
{
	return timer;
}

void ArduinoPLC32::raiseTimeEvent(sc_eventid evid)
{
	if ((evid >= (sc_eventid)timeEvents) && (evid < (sc_eventid)(&timeEvents[timeEventsCount])))
	{
		*(sc_boolean*)evid = true;
	}				
}

sc_boolean ArduinoPLC32::isStateActive(ArduinoPLC32States state)
{
	switch (state)
	{
		case main_region_State10 : 
			return (sc_boolean) (stateConfVector[0] == main_region_State10
			);
		case main_region_State11 : 
			return (sc_boolean) (stateConfVector[0] >= main_region_State11
				&& stateConfVector[0] <= main_region_State11_r2_State5);
		case main_region_State11_r1_State21 : 
			return (sc_boolean) (stateConfVector[0] == main_region_State11_r1_State21
			);
		case main_region_State11_r1_State20 : 
			return (sc_boolean) (stateConfVector[0] == main_region_State11_r1_State20
			);
		case main_region_State11_r2_State0 : 
			return (sc_boolean) (stateConfVector[1] == main_region_State11_r2_State0
			);
		case main_region_State11_r2_State1 : 
			return (sc_boolean) (stateConfVector[1] == main_region_State11_r2_State1
			);
		case main_region_State11_r2_State2 : 
			return (sc_boolean) (stateConfVector[1] == main_region_State11_r2_State2
			);
		case main_region_State11_r2_State3 : 
			return (sc_boolean) (stateConfVector[1] == main_region_State11_r2_State3
			);
		case main_region_State11_r2_State4 : 
			return (sc_boolean) (stateConfVector[1] == main_region_State11_r2_State4
			);
		case main_region_State11_r2_State5 : 
			return (sc_boolean) (stateConfVector[1] == main_region_State11_r2_State5
			);
		default: return false;
	}
}

ArduinoPLC32::DefaultSCI* ArduinoPLC32::getDefaultSCI()
{
	return &iface;
}

void ArduinoPLC32::DefaultSCI::raise_dCY()
{
	DCY_raised = true;
}

void ArduinoPLC32::raise_dCY()
{
	iface.raise_dCY();
}

void ArduinoPLC32::DefaultSCI::raise_fCY()
{
	FCY_raised = true;
}

void ArduinoPLC32::raise_fCY()
{
	iface.raise_fCY();
}

void ArduinoPLC32::DefaultSCI::raise_a1A6()
{
	a1A6_raised = true;
}

void ArduinoPLC32::raise_a1A6()
{
	iface.raise_a1A6();
}

void ArduinoPLC32::DefaultSCI::raise_a1B6()
{
	a1B6_raised = true;
}

void ArduinoPLC32::raise_a1B6()
{
	iface.raise_a1B6();
}

void ArduinoPLC32::DefaultSCI::raise_a2A6()
{
	a2A6_raised = true;
}

void ArduinoPLC32::raise_a2A6()
{
	iface.raise_a2A6();
}

void ArduinoPLC32::DefaultSCI::raise_a2B6()
{
	a2B6_raised = true;
}

void ArduinoPLC32::raise_a2B6()
{
	iface.raise_a2B6();
}


sc_integer ArduinoPLC32::DefaultSCI::get_bPATU()
{
	return BPATU;
}

sc_integer ArduinoPLC32::get_bPATU()
{
	return iface.BPATU;
}

void ArduinoPLC32::DefaultSCI::set_bPATU(sc_integer value)
{
	BPATU = value;
}

void ArduinoPLC32::set_bPATU(sc_integer value)
{
	iface.BPATU = value;
}

sc_integer ArduinoPLC32::DefaultSCI::get_aUTO()
{
	return AUTO_ID;
}

sc_integer ArduinoPLC32::get_aUTO()
{
	return iface.AUTO_ID;
}

void ArduinoPLC32::DefaultSCI::set_aUTO(sc_integer value)
{
	AUTO_ID = value;
}

void ArduinoPLC32::set_aUTO(sc_integer value)
{
	iface.AUTO_ID = value;
}

sc_boolean ArduinoPLC32::DefaultSCI::get_m()
{
	return M;
}

sc_boolean ArduinoPLC32::get_m()
{
	return iface.M;
}

void ArduinoPLC32::DefaultSCI::set_m(sc_boolean value)
{
	M = value;
}

void ArduinoPLC32::set_m(sc_boolean value)
{
	iface.M = value;
}

sc_boolean ArduinoPLC32::DefaultSCI::get_a1A1()
{
	return a1A1;
}

sc_boolean ArduinoPLC32::get_a1A1()
{
	return iface.a1A1;
}

void ArduinoPLC32::DefaultSCI::set_a1A1(sc_boolean value)
{
	a1A1 = value;
}

void ArduinoPLC32::set_a1A1(sc_boolean value)
{
	iface.a1A1 = value;
}

sc_boolean ArduinoPLC32::DefaultSCI::get_a1B1()
{
	return a1B1;
}

sc_boolean ArduinoPLC32::get_a1B1()
{
	return iface.a1B1;
}

void ArduinoPLC32::DefaultSCI::set_a1B1(sc_boolean value)
{
	a1B1 = value;
}

void ArduinoPLC32::set_a1B1(sc_boolean value)
{
	iface.a1B1 = value;
}

sc_boolean ArduinoPLC32::DefaultSCI::get_a2A1()
{
	return a2A1;
}

sc_boolean ArduinoPLC32::get_a2A1()
{
	return iface.a2A1;
}

void ArduinoPLC32::DefaultSCI::set_a2A1(sc_boolean value)
{
	a2A1 = value;
}

void ArduinoPLC32::set_a2A1(sc_boolean value)
{
	iface.a2A1 = value;
}

sc_boolean ArduinoPLC32::DefaultSCI::get_a2B1()
{
	return a2B1;
}

sc_boolean ArduinoPLC32::get_a2B1()
{
	return iface.a2B1;
}

void ArduinoPLC32::DefaultSCI::set_a2B1(sc_boolean value)
{
	a2B1 = value;
}

void ArduinoPLC32::set_a2B1(sc_boolean value)
{
	iface.a2B1 = value;
}

sc_integer ArduinoPLC32::DefaultSCI::get_potA0()
{
	return potA0;
}

sc_integer ArduinoPLC32::get_potA0()
{
	return iface.potA0;
}

void ArduinoPLC32::DefaultSCI::set_potA0(sc_integer value)
{
	potA0 = value;
}

void ArduinoPLC32::set_potA0(sc_integer value)
{
	iface.potA0 = value;
}

sc_integer ArduinoPLC32::DefaultSCI::get_potA1()
{
	return potA1;
}

sc_integer ArduinoPLC32::get_potA1()
{
	return iface.potA1;
}

void ArduinoPLC32::DefaultSCI::set_potA1(sc_integer value)
{
	potA1 = value;
}

void ArduinoPLC32::set_potA1(sc_integer value)
{
	iface.potA1 = value;
}

sc_integer ArduinoPLC32::DefaultSCI::get_analogout1()
{
	return analogout1;
}

sc_integer ArduinoPLC32::get_analogout1()
{
	return iface.analogout1;
}

void ArduinoPLC32::DefaultSCI::set_analogout1(sc_integer value)
{
	analogout1 = value;
}

void ArduinoPLC32::set_analogout1(sc_integer value)
{
	iface.analogout1 = value;
}

sc_integer ArduinoPLC32::DefaultSCI::get_analogout2()
{
	return analogout2;
}

sc_integer ArduinoPLC32::get_analogout2()
{
	return iface.analogout2;
}

void ArduinoPLC32::DefaultSCI::set_analogout2(sc_integer value)
{
	analogout2 = value;
}

void ArduinoPLC32::set_analogout2(sc_integer value)
{
	iface.analogout2 = value;
}


// implementations of all internal functions

sc_boolean ArduinoPLC32::check_main_region_State10_tr0_tr0()
{
	return iface.BPATU == 1;
}

sc_boolean ArduinoPLC32::check_main_region_State10_lr0_lr0()
{
	return true;
}

sc_boolean ArduinoPLC32::check_main_region_State10_lr1_lr1()
{
	return true;
}

sc_boolean ArduinoPLC32::check_main_region_State10_lr2_lr2()
{
	return true;
}

sc_boolean ArduinoPLC32::check_main_region_State10_lr3_lr3()
{
	return true;
}

sc_boolean ArduinoPLC32::check_main_region_State10_lr4_lr4()
{
	return true;
}

sc_boolean ArduinoPLC32::check_main_region_State10_lr5_lr5()
{
	return true;
}

sc_boolean ArduinoPLC32::check_main_region_State10_lr6_lr6()
{
	return true;
}

sc_boolean ArduinoPLC32::check_main_region_State11_tr0_tr0()
{
	return iface.BPATU == 0;
}

sc_boolean ArduinoPLC32::check_main_region_State11_r1_State21_tr0_tr0()
{
	return iface.FCY_raised;
}

sc_boolean ArduinoPLC32::check_main_region_State11_r1_State21_lr0_lr0()
{
	return true;
}

sc_boolean ArduinoPLC32::check_main_region_State11_r1_State21_lr1_lr1()
{
	return true;
}

sc_boolean ArduinoPLC32::check_main_region_State11_r1_State21_lr2_lr2()
{
	return true;
}

sc_boolean ArduinoPLC32::check_main_region_State11_r1_State20_tr0_tr0()
{
	return iface.DCY_raised;
}

sc_boolean ArduinoPLC32::check_main_region_State11_r1_State20_lr0_lr0()
{
	return true;
}

sc_boolean ArduinoPLC32::check_main_region_State11_r2_State0_tr0_tr0()
{
	return (iface.M == true) && (iface.AUTO_ID == 0);
}

sc_boolean ArduinoPLC32::check_main_region_State11_r2_State0_tr1_tr1()
{
	return iface.AUTO_ID == 1;
}

sc_boolean ArduinoPLC32::check_main_region_State11_r2_State0_lr0_lr0()
{
	return true;
}

sc_boolean ArduinoPLC32::check_main_region_State11_r2_State1_tr0_tr0()
{
	return timeEvents[0];
}

sc_boolean ArduinoPLC32::check_main_region_State11_r2_State1_lr0_lr0()
{
	return true;
}

sc_boolean ArduinoPLC32::check_main_region_State11_r2_State1_lr1_lr1()
{
	return true;
}

sc_boolean ArduinoPLC32::check_main_region_State11_r2_State2_tr0_tr0()
{
	return timeEvents[1];
}

sc_boolean ArduinoPLC32::check_main_region_State11_r2_State2_lr0_lr0()
{
	return true;
}

sc_boolean ArduinoPLC32::check_main_region_State11_r2_State2_lr1_lr1()
{
	return true;
}

sc_boolean ArduinoPLC32::check_main_region_State11_r2_State3_tr0_tr0()
{
	return timeEvents[2];
}

sc_boolean ArduinoPLC32::check_main_region_State11_r2_State3_lr0_lr0()
{
	return true;
}

sc_boolean ArduinoPLC32::check_main_region_State11_r2_State3_lr1_lr1()
{
	return true;
}

sc_boolean ArduinoPLC32::check_main_region_State11_r2_State4_tr0_tr0()
{
	return (timeEvents[3]) && (iface.M == true);
}

sc_boolean ArduinoPLC32::check_main_region_State11_r2_State4_tr1_tr1()
{
	return (timeEvents[4]) && (iface.M == false);
}

sc_boolean ArduinoPLC32::check_main_region_State11_r2_State4_lr0_lr0()
{
	return true;
}

sc_boolean ArduinoPLC32::check_main_region_State11_r2_State4_lr1_lr1()
{
	return true;
}

sc_boolean ArduinoPLC32::check_main_region_State11_r2_State5_tr0_tr0()
{
	return iface.AUTO_ID == 0;
}

sc_boolean ArduinoPLC32::check_main_region_State11_r2_State5_lr0_lr0()
{
	return true;
}

sc_boolean ArduinoPLC32::check_main_region_State11_r2_State5_lr1_lr1()
{
	return true;
}

sc_boolean ArduinoPLC32::check_main_region_State11_r2_State5_lr2_lr2()
{
	return true;
}

sc_boolean ArduinoPLC32::check_main_region_State11_r2_State5_lr3_lr3()
{
	return true;
}

void ArduinoPLC32::effect_main_region_State10_tr0()
{
	exseq_main_region_State10();
	enseq_main_region_State11_default();
}

void ArduinoPLC32::effect_main_region_State10_lr0_lr0()
{
	iface.M = false;
}

void ArduinoPLC32::effect_main_region_State10_lr1_lr1()
{
	iface.a1A1 = false;
}

void ArduinoPLC32::effect_main_region_State10_lr2_lr2()
{
	iface.a1B1 = false;
}

void ArduinoPLC32::effect_main_region_State10_lr3_lr3()
{
	iface.a2A1 = false;
}

void ArduinoPLC32::effect_main_region_State10_lr4_lr4()
{
	iface.a2B1 = false;
}

void ArduinoPLC32::effect_main_region_State10_lr5_lr5()
{
	iface.potA0 = 0;
}

void ArduinoPLC32::effect_main_region_State10_lr6_lr6()
{
	iface.potA1 = 0;
}

void ArduinoPLC32::effect_main_region_State11_tr0()
{
	exseq_main_region_State11();
	enseq_main_region_State10_default();
}

void ArduinoPLC32::effect_main_region_State11_r1_State21_tr0()
{
	exseq_main_region_State11_r1_State21();
	enseq_main_region_State11_r1_State20_default();
}

void ArduinoPLC32::effect_main_region_State11_r1_State21_lr0_lr0()
{
	iface.M = true;
}

void ArduinoPLC32::effect_main_region_State11_r1_State21_lr1_lr1()
{
	iface.analogout1 = iface.potA0;
}

void ArduinoPLC32::effect_main_region_State11_r1_State21_lr2_lr2()
{
	iface.analogout2 = iface.potA1;
}

void ArduinoPLC32::effect_main_region_State11_r1_State20_tr0()
{
	exseq_main_region_State11_r1_State20();
	enseq_main_region_State11_r1_State21_default();
}

void ArduinoPLC32::effect_main_region_State11_r1_State20_lr0_lr0()
{
	iface.M = false;
}

void ArduinoPLC32::effect_main_region_State11_r2_State0_tr0()
{
	exseq_main_region_State11_r2_State0();
	enseq_main_region_State11_r2_State1_default();
}

void ArduinoPLC32::effect_main_region_State11_r2_State0_tr1()
{
	exseq_main_region_State11_r2_State0();
	enseq_main_region_State11_r2_State5_default();
}

void ArduinoPLC32::effect_main_region_State11_r2_State0_lr0_lr0()
{
	iface.a2B1 = false;
}

void ArduinoPLC32::effect_main_region_State11_r2_State1_tr0()
{
	exseq_main_region_State11_r2_State1();
	enseq_main_region_State11_r2_State2_default();
}

void ArduinoPLC32::effect_main_region_State11_r2_State1_lr0_lr0()
{
	iface.a1A1 = true;
}

void ArduinoPLC32::effect_main_region_State11_r2_State1_lr1_lr1()
{
	iface.a2B1 = false;
}

void ArduinoPLC32::effect_main_region_State11_r2_State2_tr0()
{
	exseq_main_region_State11_r2_State2();
	enseq_main_region_State11_r2_State3_default();
}

void ArduinoPLC32::effect_main_region_State11_r2_State2_lr0_lr0()
{
	iface.a1A1 = false;
}

void ArduinoPLC32::effect_main_region_State11_r2_State2_lr1_lr1()
{
	iface.a1B1 = true;
}

void ArduinoPLC32::effect_main_region_State11_r2_State3_tr0()
{
	exseq_main_region_State11_r2_State3();
	enseq_main_region_State11_r2_State4_default();
}

void ArduinoPLC32::effect_main_region_State11_r2_State3_lr0_lr0()
{
	iface.a1B1 = false;
}

void ArduinoPLC32::effect_main_region_State11_r2_State3_lr1_lr1()
{
	iface.a2A1 = true;
}

void ArduinoPLC32::effect_main_region_State11_r2_State4_tr0()
{
	exseq_main_region_State11_r2_State4();
	enseq_main_region_State11_r2_State1_default();
}

void ArduinoPLC32::effect_main_region_State11_r2_State4_tr1()
{
	exseq_main_region_State11_r2_State4();
	enseq_main_region_State11_r2_State0_default();
}

void ArduinoPLC32::effect_main_region_State11_r2_State4_lr0_lr0()
{
	iface.a2A1 = false;
}

void ArduinoPLC32::effect_main_region_State11_r2_State4_lr1_lr1()
{
	iface.a2B1 = true;
}

void ArduinoPLC32::effect_main_region_State11_r2_State5_tr0()
{
	exseq_main_region_State11_r2_State5();
	enseq_main_region_State11_r2_State0_default();
}

void ArduinoPLC32::effect_main_region_State11_r2_State5_lr0_lr0()
{
	iface.a1A1 = iface.a1A6_raised;
}

void ArduinoPLC32::effect_main_region_State11_r2_State5_lr1_lr1()
{
	iface.a1B1 = iface.a1B6_raised;
}

void ArduinoPLC32::effect_main_region_State11_r2_State5_lr2_lr2()
{
	iface.a2A1 = iface.a2A6_raised;
}

void ArduinoPLC32::effect_main_region_State11_r2_State5_lr3_lr3()
{
	iface.a2B1 = iface.a2B6_raised;
}

/* Entry action for state 'State1'. */
void ArduinoPLC32::enact_main_region_State11_r2_State1()
{
	/* Entry action for state 'State1'. */
	timer->setTimer(this, (sc_eventid)(&timeEvents[0]), 1 * 1000, false);
}

/* Entry action for state 'State2'. */
void ArduinoPLC32::enact_main_region_State11_r2_State2()
{
	/* Entry action for state 'State2'. */
	timer->setTimer(this, (sc_eventid)(&timeEvents[1]), 1 * 1000, false);
}

/* Entry action for state 'State3'. */
void ArduinoPLC32::enact_main_region_State11_r2_State3()
{
	/* Entry action for state 'State3'. */
	timer->setTimer(this, (sc_eventid)(&timeEvents[2]), 1 * 1000, false);
}

/* Entry action for state 'State4'. */
void ArduinoPLC32::enact_main_region_State11_r2_State4()
{
	/* Entry action for state 'State4'. */
	timer->setTimer(this, (sc_eventid)(&timeEvents[3]), 1 * 1000, false);
	timer->setTimer(this, (sc_eventid)(&timeEvents[4]), 1 * 1000, false);
}

/* Exit action for state 'State1'. */
void ArduinoPLC32::exact_main_region_State11_r2_State1()
{
	/* Exit action for state 'State1'. */
	timer->unsetTimer(this, (sc_eventid)(&timeEvents[0]));
}

/* Exit action for state 'State2'. */
void ArduinoPLC32::exact_main_region_State11_r2_State2()
{
	/* Exit action for state 'State2'. */
	timer->unsetTimer(this, (sc_eventid)(&timeEvents[1]));
}

/* Exit action for state 'State3'. */
void ArduinoPLC32::exact_main_region_State11_r2_State3()
{
	/* Exit action for state 'State3'. */
	timer->unsetTimer(this, (sc_eventid)(&timeEvents[2]));
}

/* Exit action for state 'State4'. */
void ArduinoPLC32::exact_main_region_State11_r2_State4()
{
	/* Exit action for state 'State4'. */
	timer->unsetTimer(this, (sc_eventid)(&timeEvents[3]));
	timer->unsetTimer(this, (sc_eventid)(&timeEvents[4]));
}

/* 'default' enter sequence for state State10 */
void ArduinoPLC32::enseq_main_region_State10_default()
{
	/* 'default' enter sequence for state State10 */
	stateConfVector[0] = main_region_State10;
	stateConfVectorPosition = 0;
}

/* 'default' enter sequence for state State11 */
void ArduinoPLC32::enseq_main_region_State11_default()
{
	/* 'default' enter sequence for state State11 */
	enseq_main_region_State11_r1_default();
	enseq_main_region_State11_r2_default();
}

/* 'default' enter sequence for state State21 */
void ArduinoPLC32::enseq_main_region_State11_r1_State21_default()
{
	/* 'default' enter sequence for state State21 */
	stateConfVector[0] = main_region_State11_r1_State21;
	stateConfVectorPosition = 0;
}

/* 'default' enter sequence for state State20 */
void ArduinoPLC32::enseq_main_region_State11_r1_State20_default()
{
	/* 'default' enter sequence for state State20 */
	stateConfVector[0] = main_region_State11_r1_State20;
	stateConfVectorPosition = 0;
}

/* 'default' enter sequence for state State0 */
void ArduinoPLC32::enseq_main_region_State11_r2_State0_default()
{
	/* 'default' enter sequence for state State0 */
	stateConfVector[1] = main_region_State11_r2_State0;
	stateConfVectorPosition = 1;
}

/* 'default' enter sequence for state State1 */
void ArduinoPLC32::enseq_main_region_State11_r2_State1_default()
{
	/* 'default' enter sequence for state State1 */
	enact_main_region_State11_r2_State1();
	stateConfVector[1] = main_region_State11_r2_State1;
	stateConfVectorPosition = 1;
}

/* 'default' enter sequence for state State2 */
void ArduinoPLC32::enseq_main_region_State11_r2_State2_default()
{
	/* 'default' enter sequence for state State2 */
	enact_main_region_State11_r2_State2();
	stateConfVector[1] = main_region_State11_r2_State2;
	stateConfVectorPosition = 1;
}

/* 'default' enter sequence for state State3 */
void ArduinoPLC32::enseq_main_region_State11_r2_State3_default()
{
	/* 'default' enter sequence for state State3 */
	enact_main_region_State11_r2_State3();
	stateConfVector[1] = main_region_State11_r2_State3;
	stateConfVectorPosition = 1;
}

/* 'default' enter sequence for state State4 */
void ArduinoPLC32::enseq_main_region_State11_r2_State4_default()
{
	/* 'default' enter sequence for state State4 */
	enact_main_region_State11_r2_State4();
	stateConfVector[1] = main_region_State11_r2_State4;
	stateConfVectorPosition = 1;
}

/* 'default' enter sequence for state State5 */
void ArduinoPLC32::enseq_main_region_State11_r2_State5_default()
{
	/* 'default' enter sequence for state State5 */
	stateConfVector[1] = main_region_State11_r2_State5;
	stateConfVectorPosition = 1;
}

/* 'default' enter sequence for region main region */
void ArduinoPLC32::enseq_main_region_default()
{
	/* 'default' enter sequence for region main region */
	react_main_region__entry_Default();
}

/* 'default' enter sequence for region r1 */
void ArduinoPLC32::enseq_main_region_State11_r1_default()
{
	/* 'default' enter sequence for region r1 */
	react_main_region_State11_r1__entry_Default();
}

/* 'default' enter sequence for region r2 */
void ArduinoPLC32::enseq_main_region_State11_r2_default()
{
	/* 'default' enter sequence for region r2 */
	react_main_region_State11_r2__entry_Default();
}

/* Default exit sequence for state State10 */
void ArduinoPLC32::exseq_main_region_State10()
{
	/* Default exit sequence for state State10 */
	stateConfVector[0] = ArduinoPLC32_last_state;
	stateConfVectorPosition = 0;
}

/* Default exit sequence for state State11 */
void ArduinoPLC32::exseq_main_region_State11()
{
	/* Default exit sequence for state State11 */
	exseq_main_region_State11_r1();
	exseq_main_region_State11_r2();
}

/* Default exit sequence for state State21 */
void ArduinoPLC32::exseq_main_region_State11_r1_State21()
{
	/* Default exit sequence for state State21 */
	stateConfVector[0] = ArduinoPLC32_last_state;
	stateConfVectorPosition = 0;
}

/* Default exit sequence for state State20 */
void ArduinoPLC32::exseq_main_region_State11_r1_State20()
{
	/* Default exit sequence for state State20 */
	stateConfVector[0] = ArduinoPLC32_last_state;
	stateConfVectorPosition = 0;
}

/* Default exit sequence for state State0 */
void ArduinoPLC32::exseq_main_region_State11_r2_State0()
{
	/* Default exit sequence for state State0 */
	stateConfVector[1] = ArduinoPLC32_last_state;
	stateConfVectorPosition = 1;
}

/* Default exit sequence for state State1 */
void ArduinoPLC32::exseq_main_region_State11_r2_State1()
{
	/* Default exit sequence for state State1 */
	stateConfVector[1] = ArduinoPLC32_last_state;
	stateConfVectorPosition = 1;
	exact_main_region_State11_r2_State1();
}

/* Default exit sequence for state State2 */
void ArduinoPLC32::exseq_main_region_State11_r2_State2()
{
	/* Default exit sequence for state State2 */
	stateConfVector[1] = ArduinoPLC32_last_state;
	stateConfVectorPosition = 1;
	exact_main_region_State11_r2_State2();
}

/* Default exit sequence for state State3 */
void ArduinoPLC32::exseq_main_region_State11_r2_State3()
{
	/* Default exit sequence for state State3 */
	stateConfVector[1] = ArduinoPLC32_last_state;
	stateConfVectorPosition = 1;
	exact_main_region_State11_r2_State3();
}

/* Default exit sequence for state State4 */
void ArduinoPLC32::exseq_main_region_State11_r2_State4()
{
	/* Default exit sequence for state State4 */
	stateConfVector[1] = ArduinoPLC32_last_state;
	stateConfVectorPosition = 1;
	exact_main_region_State11_r2_State4();
}

/* Default exit sequence for state State5 */
void ArduinoPLC32::exseq_main_region_State11_r2_State5()
{
	/* Default exit sequence for state State5 */
	stateConfVector[1] = ArduinoPLC32_last_state;
	stateConfVectorPosition = 1;
}

/* Default exit sequence for region main region */
void ArduinoPLC32::exseq_main_region()
{
	/* Default exit sequence for region main region */
	/* Handle exit of all possible states (of arduinoPLC32.main_region) at position 0... */
	switch(stateConfVector[ 0 ])
	{
		case main_region_State10 :
		{
			exseq_main_region_State10();
			break;
		}
		case main_region_State11_r1_State21 :
		{
			exseq_main_region_State11_r1_State21();
			break;
		}
		case main_region_State11_r1_State20 :
		{
			exseq_main_region_State11_r1_State20();
			break;
		}
		default: break;
	}
	/* Handle exit of all possible states (of arduinoPLC32.main_region) at position 1... */
	switch(stateConfVector[ 1 ])
	{
		case main_region_State11_r2_State0 :
		{
			exseq_main_region_State11_r2_State0();
			break;
		}
		case main_region_State11_r2_State1 :
		{
			exseq_main_region_State11_r2_State1();
			break;
		}
		case main_region_State11_r2_State2 :
		{
			exseq_main_region_State11_r2_State2();
			break;
		}
		case main_region_State11_r2_State3 :
		{
			exseq_main_region_State11_r2_State3();
			break;
		}
		case main_region_State11_r2_State4 :
		{
			exseq_main_region_State11_r2_State4();
			break;
		}
		case main_region_State11_r2_State5 :
		{
			exseq_main_region_State11_r2_State5();
			break;
		}
		default: break;
	}
}

/* Default exit sequence for region r1 */
void ArduinoPLC32::exseq_main_region_State11_r1()
{
	/* Default exit sequence for region r1 */
	/* Handle exit of all possible states (of arduinoPLC32.main_region.State11.r1) at position 0... */
	switch(stateConfVector[ 0 ])
	{
		case main_region_State11_r1_State21 :
		{
			exseq_main_region_State11_r1_State21();
			break;
		}
		case main_region_State11_r1_State20 :
		{
			exseq_main_region_State11_r1_State20();
			break;
		}
		default: break;
	}
}

/* Default exit sequence for region r2 */
void ArduinoPLC32::exseq_main_region_State11_r2()
{
	/* Default exit sequence for region r2 */
	/* Handle exit of all possible states (of arduinoPLC32.main_region.State11.r2) at position 1... */
	switch(stateConfVector[ 1 ])
	{
		case main_region_State11_r2_State0 :
		{
			exseq_main_region_State11_r2_State0();
			break;
		}
		case main_region_State11_r2_State1 :
		{
			exseq_main_region_State11_r2_State1();
			break;
		}
		case main_region_State11_r2_State2 :
		{
			exseq_main_region_State11_r2_State2();
			break;
		}
		case main_region_State11_r2_State3 :
		{
			exseq_main_region_State11_r2_State3();
			break;
		}
		case main_region_State11_r2_State4 :
		{
			exseq_main_region_State11_r2_State4();
			break;
		}
		case main_region_State11_r2_State5 :
		{
			exseq_main_region_State11_r2_State5();
			break;
		}
		default: break;
	}
}

/* The reactions of state State10. */
void ArduinoPLC32::react_main_region_State10()
{
	/* The reactions of state State10. */
	if (check_main_region_State10_tr0_tr0())
	{ 
		effect_main_region_State10_tr0();
	}  else
	{
		effect_main_region_State10_lr0_lr0();
		effect_main_region_State10_lr1_lr1();
		effect_main_region_State10_lr2_lr2();
		effect_main_region_State10_lr3_lr3();
		effect_main_region_State10_lr4_lr4();
		effect_main_region_State10_lr5_lr5();
		effect_main_region_State10_lr6_lr6();
	}
}

/* The reactions of state State21. */
void ArduinoPLC32::react_main_region_State11_r1_State21()
{
	/* The reactions of state State21. */
	if (check_main_region_State11_tr0_tr0())
	{ 
		effect_main_region_State11_tr0();
	}  else
	{
		if (check_main_region_State11_r1_State21_tr0_tr0())
		{ 
			effect_main_region_State11_r1_State21_tr0();
		}  else
		{
			effect_main_region_State11_r1_State21_lr0_lr0();
			effect_main_region_State11_r1_State21_lr1_lr1();
			effect_main_region_State11_r1_State21_lr2_lr2();
		}
	}
}

/* The reactions of state State20. */
void ArduinoPLC32::react_main_region_State11_r1_State20()
{
	/* The reactions of state State20. */
	if (check_main_region_State11_tr0_tr0())
	{ 
		effect_main_region_State11_tr0();
	}  else
	{
		if (check_main_region_State11_r1_State20_tr0_tr0())
		{ 
			effect_main_region_State11_r1_State20_tr0();
		}  else
		{
			effect_main_region_State11_r1_State20_lr0_lr0();
		}
	}
}

/* The reactions of state State0. */
void ArduinoPLC32::react_main_region_State11_r2_State0()
{
	/* The reactions of state State0. */
	if (check_main_region_State11_r2_State0_tr0_tr0())
	{ 
		effect_main_region_State11_r2_State0_tr0();
	}  else
	{
		if (check_main_region_State11_r2_State0_tr1_tr1())
		{ 
			effect_main_region_State11_r2_State0_tr1();
		}  else
		{
			effect_main_region_State11_r2_State0_lr0_lr0();
		}
	}
}

/* The reactions of state State1. */
void ArduinoPLC32::react_main_region_State11_r2_State1()
{
	/* The reactions of state State1. */
	if (check_main_region_State11_r2_State1_tr0_tr0())
	{ 
		effect_main_region_State11_r2_State1_tr0();
	}  else
	{
		effect_main_region_State11_r2_State1_lr0_lr0();
		effect_main_region_State11_r2_State1_lr1_lr1();
	}
}

/* The reactions of state State2. */
void ArduinoPLC32::react_main_region_State11_r2_State2()
{
	/* The reactions of state State2. */
	if (check_main_region_State11_r2_State2_tr0_tr0())
	{ 
		effect_main_region_State11_r2_State2_tr0();
	}  else
	{
		effect_main_region_State11_r2_State2_lr0_lr0();
		effect_main_region_State11_r2_State2_lr1_lr1();
	}
}

/* The reactions of state State3. */
void ArduinoPLC32::react_main_region_State11_r2_State3()
{
	/* The reactions of state State3. */
	if (check_main_region_State11_r2_State3_tr0_tr0())
	{ 
		effect_main_region_State11_r2_State3_tr0();
	}  else
	{
		effect_main_region_State11_r2_State3_lr0_lr0();
		effect_main_region_State11_r2_State3_lr1_lr1();
	}
}

/* The reactions of state State4. */
void ArduinoPLC32::react_main_region_State11_r2_State4()
{
	/* The reactions of state State4. */
	if (check_main_region_State11_r2_State4_tr0_tr0())
	{ 
		effect_main_region_State11_r2_State4_tr0();
	}  else
	{
		if (check_main_region_State11_r2_State4_tr1_tr1())
		{ 
			effect_main_region_State11_r2_State4_tr1();
		}  else
		{
			effect_main_region_State11_r2_State4_lr0_lr0();
			effect_main_region_State11_r2_State4_lr1_lr1();
		}
	}
}

/* The reactions of state State5. */
void ArduinoPLC32::react_main_region_State11_r2_State5()
{
	/* The reactions of state State5. */
	if (check_main_region_State11_r2_State5_tr0_tr0())
	{ 
		effect_main_region_State11_r2_State5_tr0();
	}  else
	{
		effect_main_region_State11_r2_State5_lr0_lr0();
		effect_main_region_State11_r2_State5_lr1_lr1();
		effect_main_region_State11_r2_State5_lr2_lr2();
		effect_main_region_State11_r2_State5_lr3_lr3();
	}
}

/* Default react sequence for initial entry  */
void ArduinoPLC32::react_main_region__entry_Default()
{
	/* Default react sequence for initial entry  */
	enseq_main_region_State10_default();
}

/* Default react sequence for initial entry  */
void ArduinoPLC32::react_main_region_State11_r1__entry_Default()
{
	/* Default react sequence for initial entry  */
	enseq_main_region_State11_r1_State20_default();
}

/* Default react sequence for initial entry  */
void ArduinoPLC32::react_main_region_State11_r2__entry_Default()
{
	/* Default react sequence for initial entry  */
	enseq_main_region_State11_r2_State0_default();
}


