/* Generated by YAKINDU Statechart Tools for Arduino v0.4.0 */

#include "ArduinoPLC32Connector.h"
// #include <avr/power.h>
#include "../src-gen/SM.h"
#include "../src-gen/Mudbus.h"
#include "../src-gen/Ethernet.h"
#include "../src-gen/SPI.h"
#include "../src-gen/Mcp23s17.h"

#define circuit1_SLAVE_SELECT_PIN  2 //arduino   <->   SPI Slave Select   -> CS  (Pin 11 on MCP23S17 DIP)
#define circuit2_SLAVE_SELECT_PIN  3 //arduino   <->   SPI Slave Select    -> CS  (Pin 11 on MCP23S17 DIP)

MCP23S17 circuit1 = MCP23S17( circuit1_SLAVE_SELECT_PIN, 0x01 );//addresse 1
MCP23S17 circuit2 = MCP23S17( circuit2_SLAVE_SELECT_PIN, 0x02 );//addresse 2


int memo;
int M = 0;

float VALdac1 = 4095;
float VALdac2 = 1300;
word outputValue1 = 0; // a word is a 16-bit number
byte data1 = 0; // and a byte is an 8-bit number

#define BPATU 8
#define DCY 9
#define FCY A2
#define AUTO A3
uint16_t circuit1read;
uint16_t circuit2read;

Mudbus Mb;//create the modbus registers


ArduinoPLC32Connector::ArduinoPLC32Connector(ArduinoPLC32* statemachine) {
	this->statemachine = statemachine;
	//circuit1.digitalWrite(1, HIGH);
}

/*
 * Initialize the hardware.
 */
void ArduinoPLC32Connector::init() {

	  uint8_t mac[]     = { 0x90, 0xA2, 0xDA, 0x00, 0x51, 0x06 };
	  uint8_t ip[]      = { 192, 168, 1, 44};
	  uint8_t gateway[] = { 192, 168, 1, 1 };
	  uint8_t subnet[]  = { 255, 255, 255, 0 };
	  Ethernet.begin(mac, ip, gateway, subnet);
	  //Avoid pins 4,10,11,12,13 when using ethernet shield
	  delay(5000);
	  //push buttons

	  pinMode(DCY, INPUT);
	  pinMode(FCY, INPUT);
	  pinMode(AUTO, INPUT);
	  pinMode(BPATU, INPUT);
	  pinMode(5, OUTPUT); //analog SPI expander pin CS
	  pinMode(6, OUTPUT); //analog SPI expander pin CS

	  pinMode(circuit1_SLAVE_SELECT_PIN, OUTPUT);//digital expander pin CS
	  pinMode(circuit2_SLAVE_SELECT_PIN, OUTPUT);

	  //circuit1.pinMode(0,INPUT);//INTERNAL PULLUP NOT necessary here
	    //  unless both input would be activated,WHEN INPUT AND OUTPUT ON THE SAME CIRCUIT PORT
	    circuit1.pinMode(1, OUTPUT); //@1A1
	    circuit1.pinMode(9, OUTPUT); //@1B1
	    circuit1.digitalWrite(1, LOW);
	    circuit1.digitalWrite(9, LOW);
	    circuit1.pinMode(6, INPUT); //BP @1A6
	    circuit1.pinMode(14, INPUT); //BP @1B6

	    circuit2.pinMode(1, OUTPUT); //@2A1
	    circuit2.pinMode(9, OUTPUT); //@2B1
	    circuit2.digitalWrite(1, LOW);
	    circuit2.digitalWrite(9, LOW);
	    circuit2.pinMode(6, INPUT);//BP @2A6
	    circuit2.pinMode(14, INPUT);//BP @2B6

	    //circuit2.port(0x0000);//toutes les sorties à 0
	    SPI.begin(); // wake up the SPI bus.
	    SPI.setBitOrder(MSBFIRST);

	    //spi analog to 0V
	      outputValue1 = 0;
	      digitalWrite(5, LOW);
	      data1 = highByte(outputValue1);
	      data1 = 0b00001111 & data1;
	      data1 = 0b00110000 | data1;
	      SPI.transfer(data1);
	      data1 = lowByte(outputValue1);
	      SPI.transfer(data1);
	      digitalWrite(5, HIGH);
	      delay(50);

	      outputValue1 = 0;
	      digitalWrite(6, LOW);
	      data1 = highByte(outputValue1);
	      data1 = 0b00001111 & data1;
	      data1 = 0b00110000 | data1;
	      SPI.transfer(data1);
	      data1 = lowByte(outputValue1);
	      SPI.transfer(data1);
	      digitalWrite(6, HIGH);
	      delay(50);

	 // The state machine has already been initialized and started before
	// this method is called. Until syncState() is called the first time
	// by the state machine, the hardware is not in sync with the state
	// machine. If the cycle period is very high (let's say >> 1s), it
	// might be better to call syncState() once manually, to get in sync
	// with the initial state of the state machine.
	// syncState();
	 //     circuit1.digitalWrite(1, HIGH);
}

/*
 * Raise state machine events before processing them in the state machine's runCycle().
 */

void ArduinoPLC32Connector::raiseEvents() {
	// e.g.
	circuit1read = circuit1.port(); //read the port circuit1
    circuit2read = circuit2.port(); //read the port circuit2

    Mb.Run();

    if ((digitalRead(AUTO) == 1) || (Mb.R[19] == 1))  {
        Mb.R[51] = 1;//HMI LIGHT AUTO
        Mb.R[52] = 0;
      }
      else {
        Mb.R[51] = 0;//auto hmi light
        Mb.R[52] = 1;
      }

	// if (buttonPressed) {
	//     statemachine->raiseXYZEvent();
	// }
	if (digitalRead(BPATU) == 1) {statemachine->set_bPATU(1);}
	else statemachine->set_bPATU(0);outputValue1=0;

	if ((digitalRead(FCY) == 1)|| (Mb.R[30] == 1)) {statemachine->raise_fCY();}
	if ((digitalRead(DCY) == 1)|| (Mb.R[29] == 1)) {statemachine->raise_dCY();}
	if ((digitalRead(AUTO) == 1)|| (Mb.R[19] == 1)) statemachine->set_aUTO(0);
	else statemachine->set_aUTO(1);
	if ((bitRead(circuit1read, 6) == 1)|| (Mb.R[39] == 1)) {statemachine->raise_a1A6();}
	if ((bitRead(circuit1read, 14) == 1)|| (Mb.R[40] == 1)) {statemachine->raise_a1B6();}
	if ((bitRead(circuit2read, 6) == 1)|| (Mb.R[41] == 1)) {statemachine->raise_a2A6();}
	if ((bitRead(circuit2read, 14) == 1)|| (Mb.R[42] == 1)) {statemachine->raise_a2B6();}
	}

/*
 * Update the hardware depending on the state machine's state.
 */
void ArduinoPLC32Connector::syncState() {
	// digitalWrite(LED_BUILTIN, statemachine->get_XYZ());
	  circuit1.digitalWrite(1, statemachine->get_a1A1());
	  Mb.R[139] = statemachine->get_a1A1();
	  circuit1.digitalWrite(9, statemachine->get_a1B1());
	  Mb.R[140] = statemachine->get_a1B1();
	  circuit2.digitalWrite(1, statemachine->get_a2A1());
	  Mb.R[141] = statemachine->get_a2A1();
	  circuit2.digitalWrite(9, statemachine->get_a2B1());
	  Mb.R[142] = statemachine->get_a2B1();
	  Mb.R[50] = statemachine->get_m();
	  Mb.R[49] =not( statemachine->get_bPATU());



	  if ((statemachine->get_m())==0) {outputValue1=0;Mb.R[169]=0;Mb.R[179]=0;}
	  else{
		outputValue1=Mb.R[69]*40.9;
	    Mb.R[169]= outputValue1;
	    Mb.R[170]=Mb.R[69];
	    digitalWrite(5, LOW);
	    data1 = highByte(outputValue1);
	    data1 = 0b00001111 & data1;
	    data1 = 0b00110000 | data1;
	    SPI.transfer(data1);
	    data1 = lowByte(outputValue1);
	    SPI.transfer(data1);
	    digitalWrite(5, HIGH);


	    outputValue1 = Mb.R[79] * 40.9;
	    Mb.R[179]=outputValue1;
	    Mb.R[180]=Mb.R[79];
	    digitalWrite(6, LOW);
	    data1 = highByte(outputValue1);
	    data1 = 0b00001111 & data1;
	    data1 = 0b00110000 | data1;
	    SPI.transfer(data1);
	    data1 = lowByte(outputValue1);
	    SPI.transfer(data1);
	    digitalWrite(6, HIGH);
	  }
}


/*
 * Optimize power consumption by turning off hardware modules that are not needed.
 */
/*
void ArduinoPLC32::runCycle(){

}*/


uint8_t ArduinoPLC32Connector::prepareSleepMode() {
	// Some of the functions of <avr/power.h> may not be supported by the
	// actual microprocessor you are using.
	// This method is only called in case you are using an AVR hardware timer.
	// e.g.
	// power_adc_disable();
	// power_spi_disable();
	// power_timer0_disable();
	// power_timer1_disable() ;
	// power_timer2_disable() ;
	// power_timer3_disable() ;
	// power_twi_disable();
	// power_usart0_disable();
	// power_usb_disable();



	return SLEEP_MODE_IDLE;
}
